<?php

namespace LogBook\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSDSandLabelFiles ArrayType
 * @subpackage Arrays
 */
class ArrayOfSDSandLabelFiles extends AbstractStructArrayBase
{
    /**
     * The SDSandLabelFiles
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \LogBook\StructType\SDSandLabelFiles[]
     */
    public $SDSandLabelFiles;
    /**
     * Constructor method for ArrayOfSDSandLabelFiles
     * @uses ArrayOfSDSandLabelFiles::setSDSandLabelFiles()
     * @param \LogBook\StructType\SDSandLabelFiles[] $sDSandLabelFiles
     */
    public function __construct(array $sDSandLabelFiles = array())
    {
        $this
            ->setSDSandLabelFiles($sDSandLabelFiles);
    }
    /**
     * Get SDSandLabelFiles value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \LogBook\StructType\SDSandLabelFiles[]|null
     */
    public function getSDSandLabelFiles()
    {
        return isset($this->SDSandLabelFiles) ? $this->SDSandLabelFiles : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSDSandLabelFiles method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSDSandLabelFiles method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSDSandLabelFilesForArrayConstraintsFromSetSDSandLabelFiles(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSDSandLabelFilesSDSandLabelFilesItem) {
            // validation for constraint: itemType
            if (!$arrayOfSDSandLabelFilesSDSandLabelFilesItem instanceof \LogBook\StructType\SDSandLabelFiles) {
                $invalidValues[] = is_object($arrayOfSDSandLabelFilesSDSandLabelFilesItem) ? get_class($arrayOfSDSandLabelFilesSDSandLabelFilesItem) : sprintf('%s(%s)', gettype($arrayOfSDSandLabelFilesSDSandLabelFilesItem), var_export($arrayOfSDSandLabelFilesSDSandLabelFilesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SDSandLabelFiles property can only contain items of type \LogBook\StructType\SDSandLabelFiles, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SDSandLabelFiles value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \LogBook\StructType\SDSandLabelFiles[] $sDSandLabelFiles
     * @return \LogBook\ArrayType\ArrayOfSDSandLabelFiles
     */
    public function setSDSandLabelFiles(array $sDSandLabelFiles = array())
    {
        // validation for constraint: array
        if ('' !== ($sDSandLabelFilesArrayErrorMessage = self::validateSDSandLabelFilesForArrayConstraintsFromSetSDSandLabelFiles($sDSandLabelFiles))) {
            throw new \InvalidArgumentException($sDSandLabelFilesArrayErrorMessage, __LINE__);
        }
        if (is_null($sDSandLabelFiles) || (is_array($sDSandLabelFiles) && empty($sDSandLabelFiles))) {
            unset($this->SDSandLabelFiles);
        } else {
            $this->SDSandLabelFiles = $sDSandLabelFiles;
        }
        return $this;
    }
    /**
     * Add item to SDSandLabelFiles value
     * @throws \InvalidArgumentException
     * @param \LogBook\StructType\SDSandLabelFiles $item
     * @return \LogBook\ArrayType\ArrayOfSDSandLabelFiles
     */
    public function addToSDSandLabelFiles(\LogBook\StructType\SDSandLabelFiles $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \LogBook\StructType\SDSandLabelFiles) {
            throw new \InvalidArgumentException(sprintf('The SDSandLabelFiles property can only contain items of type \LogBook\StructType\SDSandLabelFiles, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SDSandLabelFiles[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \LogBook\StructType\SDSandLabelFiles|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \LogBook\StructType\SDSandLabelFiles|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \LogBook\StructType\SDSandLabelFiles|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \LogBook\StructType\SDSandLabelFiles|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \LogBook\StructType\SDSandLabelFiles|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SDSandLabelFiles
     */
    public function getAttributeName()
    {
        return 'SDSandLabelFiles';
    }
}
