<?php

namespace LogBook\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSDSandLabelWithoutFiles ArrayType
 * @subpackage Arrays
 */
class ArrayOfSDSandLabelWithoutFiles extends AbstractStructArrayBase
{
    /**
     * The SDSandLabelWithoutFiles
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \LogBook\StructType\SDSandLabelWithoutFiles[]
     */
    public $SDSandLabelWithoutFiles;
    /**
     * Constructor method for ArrayOfSDSandLabelWithoutFiles
     * @uses ArrayOfSDSandLabelWithoutFiles::setSDSandLabelWithoutFiles()
     * @param \LogBook\StructType\SDSandLabelWithoutFiles[] $sDSandLabelWithoutFiles
     */
    public function __construct(array $sDSandLabelWithoutFiles = array())
    {
        $this
            ->setSDSandLabelWithoutFiles($sDSandLabelWithoutFiles);
    }
    /**
     * Get SDSandLabelWithoutFiles value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \LogBook\StructType\SDSandLabelWithoutFiles[]|null
     */
    public function getSDSandLabelWithoutFiles()
    {
        return isset($this->SDSandLabelWithoutFiles) ? $this->SDSandLabelWithoutFiles : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSDSandLabelWithoutFiles method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSDSandLabelWithoutFiles method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSDSandLabelWithoutFilesForArrayConstraintsFromSetSDSandLabelWithoutFiles(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSDSandLabelWithoutFilesSDSandLabelWithoutFilesItem) {
            // validation for constraint: itemType
            if (!$arrayOfSDSandLabelWithoutFilesSDSandLabelWithoutFilesItem instanceof \LogBook\StructType\SDSandLabelWithoutFiles) {
                $invalidValues[] = is_object($arrayOfSDSandLabelWithoutFilesSDSandLabelWithoutFilesItem) ? get_class($arrayOfSDSandLabelWithoutFilesSDSandLabelWithoutFilesItem) : sprintf('%s(%s)', gettype($arrayOfSDSandLabelWithoutFilesSDSandLabelWithoutFilesItem), var_export($arrayOfSDSandLabelWithoutFilesSDSandLabelWithoutFilesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SDSandLabelWithoutFiles property can only contain items of type \LogBook\StructType\SDSandLabelWithoutFiles, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SDSandLabelWithoutFiles value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \LogBook\StructType\SDSandLabelWithoutFiles[] $sDSandLabelWithoutFiles
     * @return \LogBook\ArrayType\ArrayOfSDSandLabelWithoutFiles
     */
    public function setSDSandLabelWithoutFiles(array $sDSandLabelWithoutFiles = array())
    {
        // validation for constraint: array
        if ('' !== ($sDSandLabelWithoutFilesArrayErrorMessage = self::validateSDSandLabelWithoutFilesForArrayConstraintsFromSetSDSandLabelWithoutFiles($sDSandLabelWithoutFiles))) {
            throw new \InvalidArgumentException($sDSandLabelWithoutFilesArrayErrorMessage, __LINE__);
        }
        if (is_null($sDSandLabelWithoutFiles) || (is_array($sDSandLabelWithoutFiles) && empty($sDSandLabelWithoutFiles))) {
            unset($this->SDSandLabelWithoutFiles);
        } else {
            $this->SDSandLabelWithoutFiles = $sDSandLabelWithoutFiles;
        }
        return $this;
    }
    /**
     * Add item to SDSandLabelWithoutFiles value
     * @throws \InvalidArgumentException
     * @param \LogBook\StructType\SDSandLabelWithoutFiles $item
     * @return \LogBook\ArrayType\ArrayOfSDSandLabelWithoutFiles
     */
    public function addToSDSandLabelWithoutFiles(\LogBook\StructType\SDSandLabelWithoutFiles $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \LogBook\StructType\SDSandLabelWithoutFiles) {
            throw new \InvalidArgumentException(sprintf('The SDSandLabelWithoutFiles property can only contain items of type \LogBook\StructType\SDSandLabelWithoutFiles, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SDSandLabelWithoutFiles[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \LogBook\StructType\SDSandLabelWithoutFiles|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \LogBook\StructType\SDSandLabelWithoutFiles|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \LogBook\StructType\SDSandLabelWithoutFiles|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \LogBook\StructType\SDSandLabelWithoutFiles|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \LogBook\StructType\SDSandLabelWithoutFiles|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SDSandLabelWithoutFiles
     */
    public function getAttributeName()
    {
        return 'SDSandLabelWithoutFiles';
    }
}
