<?php

namespace LogBook\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfSpragueNumbers ArrayType
 * @subpackage Arrays
 */
class ArrayOfSpragueNumbers extends AbstractStructArrayBase
{
    /**
     * The SpragueNumbers
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \LogBook\StructType\SpragueNumbers[]
     */
    public $SpragueNumbers;
    /**
     * Constructor method for ArrayOfSpragueNumbers
     * @uses ArrayOfSpragueNumbers::setSpragueNumbers()
     * @param \LogBook\StructType\SpragueNumbers[] $spragueNumbers
     */
    public function __construct(array $spragueNumbers = array())
    {
        $this
            ->setSpragueNumbers($spragueNumbers);
    }
    /**
     * Get SpragueNumbers value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \LogBook\StructType\SpragueNumbers[]|null
     */
    public function getSpragueNumbers()
    {
        return isset($this->SpragueNumbers) ? $this->SpragueNumbers : null;
    }
    /**
     * This method is responsible for validating the values passed to the setSpragueNumbers method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSpragueNumbers method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSpragueNumbersForArrayConstraintsFromSetSpragueNumbers(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfSpragueNumbersSpragueNumbersItem) {
            // validation for constraint: itemType
            if (!$arrayOfSpragueNumbersSpragueNumbersItem instanceof \LogBook\StructType\SpragueNumbers) {
                $invalidValues[] = is_object($arrayOfSpragueNumbersSpragueNumbersItem) ? get_class($arrayOfSpragueNumbersSpragueNumbersItem) : sprintf('%s(%s)', gettype($arrayOfSpragueNumbersSpragueNumbersItem), var_export($arrayOfSpragueNumbersSpragueNumbersItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SpragueNumbers property can only contain items of type \LogBook\StructType\SpragueNumbers, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SpragueNumbers value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \LogBook\StructType\SpragueNumbers[] $spragueNumbers
     * @return \LogBook\ArrayType\ArrayOfSpragueNumbers
     */
    public function setSpragueNumbers(array $spragueNumbers = array())
    {
        // validation for constraint: array
        if ('' !== ($spragueNumbersArrayErrorMessage = self::validateSpragueNumbersForArrayConstraintsFromSetSpragueNumbers($spragueNumbers))) {
            throw new \InvalidArgumentException($spragueNumbersArrayErrorMessage, __LINE__);
        }
        if (is_null($spragueNumbers) || (is_array($spragueNumbers) && empty($spragueNumbers))) {
            unset($this->SpragueNumbers);
        } else {
            $this->SpragueNumbers = $spragueNumbers;
        }
        return $this;
    }
    /**
     * Add item to SpragueNumbers value
     * @throws \InvalidArgumentException
     * @param \LogBook\StructType\SpragueNumbers $item
     * @return \LogBook\ArrayType\ArrayOfSpragueNumbers
     */
    public function addToSpragueNumbers(\LogBook\StructType\SpragueNumbers $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \LogBook\StructType\SpragueNumbers) {
            throw new \InvalidArgumentException(sprintf('The SpragueNumbers property can only contain items of type \LogBook\StructType\SpragueNumbers, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SpragueNumbers[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \LogBook\StructType\SpragueNumbers|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \LogBook\StructType\SpragueNumbers|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \LogBook\StructType\SpragueNumbers|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \LogBook\StructType\SpragueNumbers|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \LogBook\StructType\SpragueNumbers|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SpragueNumbers
     */
    public function getAttributeName()
    {
        return 'SpragueNumbers';
    }
}
